import pandas as pd
import numpy as np
from tqdm import tqdm
import os

category = 'beauty' #categories: beauty, beverage

dataset = pd.read_csv('./'+category+'_extended.csv', sep=';', index_col='Brand')

dataset[['H','S','V','Arrogant_pct']].head()
criterions = dataset.columns.values[:-8]
attributes = dataset.columns.values[-8:]

shape_values = list(np.squeeze(dataset[['Shape']].apply(pd.Series.unique).values))
mot_values = list(np.squeeze(dataset[['Mark_or_text']].apply(pd.Series.unique).values))

dataset[['Edge_Percent', 'Symmetry_Horizontal', 'Symmetry_Vertical']] = dataset[['Edge_Percent', 'Symmetry_Horizontal', 'Symmetry_Vertical']].apply(lambda x: np.int32(np.round(x*100,0)))

''' # WYKRESY
plot_values = dataset.groupby('Shape').count()
plot_labels = plot_values.index
plot_values = plot_values.values[:,0]
plt.subplot(211)
plt.bar(range(len(plot_values)), plot_values, tick_label = plot_labels)
plt.xlabel('Shape')
plt.ylabel('Number of examples')
plot_values = dataset.groupby('Mark_or_text').count()
plot_labels = plot_values.index
plot_values = plot_values.values[:,0]
plt.subplot(212)
plt.bar(range(len(plot_values)), plot_values, tick_label = plot_labels)
plt.xlabel('Mark or text')
plt.ylabel('Number of examples')
plt.savefig('./extended/'+category+'shape_mot.pdf')

plt.figure()
dataset.boxplot(column=['Edge_Percent', 'Symmetry_Horizontal', 'Symmetry_Vertical'])
plt.ylabel('Value [%]')
plt.savefig('./extended/'+category+'edges_sym.pdf')
'''

#criterion = 'Arrogant_pct'
for criterion in tqdm(criterions):

    new_att_names = ['Brand']
    for att in attributes:
        if(att == 'Shape'):
            for shape in shape_values:
                new_att_names.append(att+'_'+shape+'_I')
                new_att_names.append(att+'_'+shape+'_II')
        elif(att == 'Mark_or_text'):
            for mot in mot_values:
                new_att_names.append(mot+'_I')
                new_att_names.append(mot+'_II')
        else:
            new_att_names.append(att+'_I')
            new_att_names.append(att+'_II')
    new_att_names.append(criterion)
          
    examples = ''
    for brand,row in zip(dataset.index,dataset[[*attributes,*[criterion]]].values):
        brand_to_add = brand.replace('&','').replace('.','').replace('(','').replace(')','').replace('-','_')
        examples += brand_to_add +', '
        for i,att in enumerate(attributes):
            if(att == 'Shape'):
                for shape in shape_values:
                    examples+= '1, 1, ' if row[i] == shape else '0, 0, '
            elif(att == 'Mark_or_text'):
                for mot in mot_values:
                    examples+= '1, 1, ' if row[i] == mot else '0, 0, '
            else:
                examples += str(row[i])+', '+str(row[i])+', '
        examples += str(row[-1])+'\n'
    
	#lokacja zapisanych plików
    os.mkdir('./extended/isf/'+category+'/'+category+'_'+criterion)
    file_out = open('./extended/isf/'+category+'/'+category+'_'+criterion+'/'+category+'_'+criterion+'.isf', 'w')
    text = ''
    text+='**ATTRIBUTES\n\n- Brand: (nominal), gain, description'
    for att in new_att_names[1:]:
        text+='\n+ '+att+': (continuous), '+ ('cost' if '_II' in att else 'gain')
    text+=', decision\n\ndecision: '+criterion+'\n\n**PREFERENCES\n'
    for att in new_att_names:
        text+='\n'+att+': '+ ('cost' if '_II' in att else 'gain')
    text+='\n\n**EXAMPLES\n\n'
    
    file_out.writelines(text)
    file_out.writelines(examples)
    file_out.write('\n**END')
    file_out.flush()
    
    file_out.close()
    lines = examples.split('\n')
